CON

VAR

byte  I2C_SDA
byte  I2C_SCL

byte  AdcUpper
byte  AdcLower

PUB Start(SDA, SCL)

  I2C_SDA := SDA
  I2C_SCL := SCL

  outa[I2C_SCL] := 1   
  outa[I2C_SDA] := 0

PUB Request_Read(Addr, Channel) |  i, i2cWriteData, i2cData 
    
  dira[I2C_SDA] := 1    'start
  outa[I2C_SCL] := 0                                              
  dira[I2C_SCL] := 1
                                                                  
  'Write adress                                                               
  i2cWriteData := (%11010000 | (Addr << 1)) >< 8
  repeat 8                                                                  
    dira[I2C_SDA] := i2cWriteData ^ 1 & 1                                   
    i2cWriteData >>= 1                                                      
    outa[I2C_SCL] := 1                                                      
    outa[I2C_SCL] := 0                                                                            
  dira[I2C_SDA] := 0   'ack from ADC                                        
  outa[I2C_SCL] := 1                                                        
  'read ACK here if necessary                                               
  outa[I2C_SCL] := 0  

  
  'Write configuration
  i2cWriteData := (%0001_0000 | (Channel << 5)) >< 8                       '        
  repeat 8                                                                  
    dira[I2C_SDA] := i2cWriteData ^ 1 & 1                                   
    i2cWriteData >>= 1                                                      
    outa[I2C_SCL] := 1                                                      
    outa[I2C_SCL] := 0                                                               
  dira[I2C_SDA] := 0   'ack from ADC                                        
  outa[I2C_SCL] := 1                                                        
  'read ACK here if necessary                                               
  outa[I2C_SCL] := 0
  
  outa[I2C_SCL] := 1       'stop condition
  dira[I2C_SCL] := 0
  
PUB Read(Addr) |  i, i2cWriteData, i2cData

  'Read Value in Channel   
  dira[I2C_SDA] := 1    'start
  outa[I2C_SCL] := 0                                              
  dira[I2C_SCL] := 1
                                                                  
  'write                                                                
  i2cWriteData := (%11010001 | (Addr << 1)) >< 8                        
  repeat 8                                                                  
    dira[I2C_SDA] := i2cWriteData ^ 1 & 1                                   
    i2cWriteData >>= 1                                                      
    outa[I2C_SCL] := 1                                                      
    outa[I2C_SCL] := 0                                                                           
  dira[I2C_SDA] := 0   'ack from ADC                                        
  outa[I2C_SCL] := 1                                                        
  'read ACK here if necessary                                               
  outa[I2C_SCL] := 0                                                       
                                                                            
  'read1                                                                    
  i2cData := 0                                                              
  repeat 8                                                                  
    outa[I2C_SCL] := 1                                                      
    i2cData := (i2cData << 1) | ina[I2C_SDA]                                
    outa[I2C_SCL] := 0                                                      
  dira[I2C_SDA] := 1                                                        
  outa[I2C_SCL] := 1                                                        
  outa[I2C_SCL] := 0                                                        
  dira[I2C_SDA] := 0                                                        
  AdcUpper := i2cData                                                        
                                                                            
  'read2                                                                    
  i2cData := 0                                                              
  repeat 8                                                                  
    outa[I2C_SCL] := 1                                                      
    i2cData := (i2cData << 1) | ina[I2C_SDA]                                
    outa[I2C_SCL] := 0                                                      
  dira[I2C_SDA] := 1    'ACK                                                
  outa[I2C_SCL] := 1                                                        
  outa[I2C_SCL] := 0
  dira[I2C_SDA] := 0                                                          
  AdcLower := i2cData                                                        

  'read config                                                                    
  i2cData := 0                                                              
  repeat 8                                                                  
    outa[I2C_SCL] := 1                                                      
    i2cData := (i2cData << 1) | ina[I2C_SDA]                                
    outa[I2C_SCL] := 0                                                      
  dira[I2C_SDA] := 1    'ACK
                                             
  outa[I2C_SCL] := 1    'stop condition                       
  dira[I2C_SDA] := 0
  dira[I2C_SCL] := 0
  
  return (AdcLower + (AdcUpper * 256))
 